"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "MultiProccessTaskThrottle", {
  enumerable: true,
  get: function get() {
    return _taskThrottle.MultiProccessTaskThrottle;
  }
});
Object.defineProperty(exports, "modelSetting", {
  enumerable: true,
  get: function get() {
    return _Decorators.modelSetting;
  }
});
Object.defineProperty(exports, "cacheAble", {
  enumerable: true,
  get: function get() {
    return _Decorators.cacheAble;
  }
});
Object.defineProperty(exports, "clearCache", {
  enumerable: true,
  get: function get() {
    return _Decorators.clearCache;
  }
});
Object.defineProperty(exports, "crashAfterMe", {
  enumerable: true,
  get: function get() {
    return _Decorators.crashAfterMe;
  }
});
Object.defineProperty(exports, "getCacheManage", {
  enumerable: true,
  get: function get() {
    return _Decorators.getCacheManage;
  }
});
Object.defineProperty(exports, "GKCache_remember", {
  enumerable: true,
  get: function get() {
    return _Decorators.GKCache_remember;
  }
});
Object.defineProperty(exports, "GKCache_remove", {
  enumerable: true,
  get: function get() {
    return _Decorators.GKCache_remove;
  }
});
Object.defineProperty(exports, "setting_redisConfig", {
  enumerable: true,
  get: function get() {
    return _redisClient.setting_redisConfig;
  }
});
Object.defineProperty(exports, "getRedisClient", {
  enumerable: true,
  get: function get() {
    return _redisClient.getRedisClient;
  }
});
Object.defineProperty(exports, "GKErrorWrap", {
  enumerable: true,
  get: function get() {
    return _GKErrorWrap.GKErrorWrap;
  }
});
Object.defineProperty(exports, "setting_CustomRuleValidator", {
  enumerable: true,
  get: function get() {
    return _index.setting_CustomRuleValidator;
  }
});
exports.responseWeixinSiteAuthFileMiddleWare = exports.responsiveCrosOriginForGankaoDomainMiddleWare_HOC = exports.responsiveCrosOriginForGankaoDomainMiddleWare = exports.GKSUCCESS = exports.createServerInRouter = exports.createServer = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _express = _interopRequireDefault(require("express"));

var _cookieParser = _interopRequireDefault(require("cookie-parser"));

var _url2 = _interopRequireDefault(require("url"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _lodash = require("lodash");

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _compression = _interopRequireDefault(require("compression"));

var _taskThrottle = require("./taskThrottle");

var _logger = _interopRequireDefault(require("./logger.js"));

var _log4js = _interopRequireDefault(require("log4js"));

var ModelProxy = _interopRequireWildcard(require("./ModelProxy"));

var _Decorators = require("./Decorators");

var _redisClient = require("./redisClient");

var _GKErrorWrap = require("./GKErrorWrap");

var _index = require("../rulehelper/index");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

console.dir("Nice to meet U, I will help You to map Class to API interface ....");
var logger = (0, _logger["default"])();
var allow_Header = ['cros_origin_hint', 'Origin', 'refererClientProvide', 'X-Requested-With', 'Content-Type', 'Accept', 'Authorization', 'jwtoken', 'gkauthorization', 'token', 'frontpage', 'withCredentials', 'credentials'].map(function (item) {
  return item.toLowerCase();
});

var _server;

var _router;

var defaultTrustDomains = ['.gankao.com', '.gygaokao.com', '.gankao100.com', '.gankaodashi.com'];

var _create_server =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(model, options) {
    var _options, config, custom, modelClasses, beforeCall, afterCall, method404, _ref2, _ref2$cros, cros, _ref2$cros_headers, cros_headers, _ref2$cros_origin, cros_origin, _ref2$frontpage_defau, frontpage_default, _ref2$apiroot, apiroot, redis, _modelClasses;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            //当options为class时，做转化封装
            if (typeof options === "function" && options instanceof Object) {
              options = {
                modelClasses: [options]
              };
            }

            _options = options, config = _options.config, custom = _options.custom, modelClasses = _options.modelClasses, beforeCall = _options.beforeCall, afterCall = _options.afterCall, method404 = _options.method404; // if (model==='server' && typeof config !== "function") {
            //     throw  `server模式下，配置参数中必需传入config[Function]属性`
            // }

            _ref2 = typeof config === "function" ? config() : config || {}, _ref2$cros = _ref2.cros, cros = _ref2$cros === void 0 ? true : _ref2$cros, _ref2$cros_headers = _ref2.cros_headers, cros_headers = _ref2$cros_headers === void 0 ? [] : _ref2$cros_headers, _ref2$cros_origin = _ref2.cros_origin, cros_origin = _ref2$cros_origin === void 0 ? [] : _ref2$cros_origin, _ref2$frontpage_defau = _ref2.frontpage_default, frontpage_default = _ref2$frontpage_defau === void 0 ? '' : _ref2$frontpage_defau, _ref2$apiroot = _ref2.apiroot, apiroot = _ref2$apiroot === void 0 ? '/' : _ref2$apiroot, redis = _ref2.redis;

            if (!redis) {
              _context.next = 8;
              break;
            }

            _context.next = 6;
            return (0, _redisClient.setting_redisConfig)(redis);

          case 6:
            _context.next = 8;
            return (0, _redisClient.getRedisClient)();

          case 8:
            _modelClasses = typeof modelClasses === "function" ? modelClasses() : modelClasses || [];

            if (_modelClasses instanceof Array) {
              _context.next = 11;
              break;
            }

            throw new Error("\u65E0\u6CD5\u8BC6\u522B\u6307\u5B9A\u7684\u7C7B\u6E05\u5355\uFF0C\u56E0\u4E3AmodelClasses\u914D\u7F6E\u9879\u683C\u5F0F\u6709\u8BEF\uFF0C\u671F\u671B\u662FArray\u5217\u8868");

          case 11:
            _context.next = 13;
            return _create_router({
              apiroot: apiroot,
              modelClasses: _modelClasses,
              beforeCall: beforeCall,
              afterCall: afterCall,
              method404: method404,
              frontpage_default: frontpage_default
            });

          case 13:
            _router = _context.sent;

            if (!(model === 'router')) {
              _context.next = 17;
              break;
            }

            // API相关路由,在main内部映射到各个功能Model
            console.log("\u4EE5\u8DEF\u7531\u7ED1\u5B9A\u6A21\u5F0F\u5F00\u542Fclass2api\uFF0Ccros\u8DE8\u57DF\u8BBE\u7F6E\u3001session\u3001\u7B49\u914D\u7F6E\u90FD\u5C06\u5FFD\u7565\uFF0C\u7531\u5916\u90E8\u7684express\u5B9E\u4F8B\u63A7\u5236\uFF01");
            return _context.abrupt("return", _router);

          case 17:
            // Security
            _server = (0, _express["default"])();

            _server.disable("x-powered-by");

            _server.use(_bodyParser["default"].json()); // for parsing application/json


            _server.use(_bodyParser["default"].urlencoded({
              extended: true
            })); // for parsing application/x-www-form-urlencoded


            _server.use(_bodyParser["default"].json({
              limit: "5000kb"
            })); // _server.use(hpp());
            // _server.use(helmet.xssFilter());
            // _server.use(helmet.frameguard("deny"));
            // _server.use(helmet.ieNoOpen());
            // _server.use(helmet.noSniff());


            _server.use((0, _cookieParser["default"])());

            _server.use((0, _compression["default"])());

            _server.use(_log4js["default"].connectLogger(logger, {
              level: _log4js["default"].levels.INFO,
              format: ':method :url'
            })); //session 禁用
            //
            //启用Session，可选Redis存储。PM2集群模式时，必须用分布式存储
            // let sessionOpt = {
            //     secret: sessionSecret,
            //     key: sessionKey,
            //     resave: false,
            //     saveUninitialized: true,
            //     cookie: {maxAge: 8000 * 1000}
            // }
            // if (sessionUseRedis) {
            //     if(!redis) {
            //         throw  `开启sessionUseRedis时，必需定义redis配置`
            //     }
            //     //REDIS_SESSION
            //     const RedisStore = connectRedis(session);
            //     sessionOpt.store = new RedisStore({
            //         host: redis.host,
            //         port: redis.port,
            //         pass: redis.password || ''
            //     })
            //     console.log('Session存储方式：Redis ....')
            // } else {
            //     console.log('Session存储方式：进程内存 ....')
            // }
            // _server.use(session(sessionOpt));
            // if (staticPath) {
            //     _server.use(express.static(staticPath));
            // }


            if (cros) {
              //设置跨域访问
              cros_origin = cros_origin.map(function (item) {
                return item.toLowerCase();
              });
              cros_headers = cros_headers.map(function (item) {
                return item.toLowerCase();
              }); //注意下方还有一个独立Export的工具函数responsiveCrosOriginForGankaoDomain，维护时需同步修改

              _server.use(responsiveCrosOriginForGankaoDomainMiddleWare_HOC({
                cros_origin: cros_origin,
                cros_headers: cros_headers
              }));
            }

            if (!(typeof custom === "function")) {
              _context.next = 30;
              break;
            }

            _context.next = 29;
            return custom(_server);

          case 29:
            _server = _context.sent;

          case 30:
            _server.use(apiroot, _router); // catch 404 and forward to error handler


            _server.use(function (req, res, next) {
              res.status = 404;
              res.json({
                err: 'API Not Defined!',
                result: null
              });
            });

            return _context.abrupt("return", _server);

          case 33:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function _create_server(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _create_router =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(_ref4) {
    var apiroot, _modelClasses, beforeCall, afterCall, method404, frontpage_default;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            apiroot = _ref4.apiroot, _modelClasses = _ref4.modelClasses, beforeCall = _ref4.beforeCall, afterCall = _ref4.afterCall, method404 = _ref4.method404, frontpage_default = _ref4.frontpage_default;
            _context2.next = 3;
            return ModelProxy.CreateListenRouter({
              apiroot: apiroot,
              modelClasses: _modelClasses,
              beforeCall: beforeCall,
              afterCall: afterCall,
              method404: method404,
              frontpage_default: frontpage_default
            });

          case 3:
            return _context2.abrupt("return", _context2.sent);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function _create_router(_x3) {
    return _ref3.apply(this, arguments);
  };
}();
/**
 * 以Server（内置Express）的方式运行API微服务
 *
 * @param options
 * @returns {Promise.<*>}
 */


var createServer =
/*#__PURE__*/
function () {
  var _ref5 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3(options) {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (_server) {
              _context3.next = 4;
              break;
            }

            _context3.next = 3;
            return _create_server('server', options);

          case 3:
            _server = _context3.sent;

          case 4:
            return _context3.abrupt("return", _server);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function createServer(_x4) {
    return _ref5.apply(this, arguments);
  };
}();

exports.createServer = createServer;

var responseWeixinSiteAuthFileMiddleWare =
/*#__PURE__*/
function () {
  var _ref6 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee4(req, res, next) {
    var _url, result, content;

    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!(req.path.indexOf("/") !== -1 && req.path.endsWith(".txt"))) {
              _context4.next = 12;
              break;
            }

            _url = "https://static.qiaoxuesi.com".concat(req.path);
            console.log("\u8F6C\u5411\u8BF7\u6C42\u5FAE\u4FE1\u63A2\u9488\u5185\u5BB9\uFF1A".concat(_url, " "));
            _context4.next = 5;
            return (0, _isomorphicFetch["default"])(_url);

          case 5:
            result = _context4.sent;
            _context4.next = 8;
            return result.text();

          case 8:
            content = _context4.sent;

            if (content.indexOf("Document not found") !== -1) {
              console.log("CDN\u5FAE\u4FE1\u63A2\u9488\u6587\u4EF6(".concat(_url, ")\u4E0D\u5B58\u5728\uFF0C\u7EE7\u7EED\u5F80\u4E0B\u8DEF\u7531...")); //CDN文档不存在，则继续往下路由

              next();
            } else {
              //输出
              res.send(content);
            }

            _context4.next = 13;
            break;

          case 12:
            next();

          case 13:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function responseWeixinSiteAuthFileMiddleWare(_x5, _x6, _x7) {
    return _ref6.apply(this, arguments);
  };
}();

exports.responseWeixinSiteAuthFileMiddleWare = responseWeixinSiteAuthFileMiddleWare;

var responsiveCrosOriginForGankaoDomainMiddleWare_HOC = function responsiveCrosOriginForGankaoDomainMiddleWare_HOC(options) {
  var _ref7 = options || {},
      _ref7$cros_origin = _ref7.cros_origin,
      cros_origin = _ref7$cros_origin === void 0 ? [] : _ref7$cros_origin,
      _ref7$cros_headers = _ref7.cros_headers,
      cros_headers = _ref7$cros_headers === void 0 ? [] : _ref7$cros_headers;

  var _cros_origin_setting = {
    cros_origin: cros_origin,
    cros_headers: cros_headers
  };
  return function (req, res, next) {
    return responsiveCrosOriginForGankaoDomainMiddleWare(req, res, next, _cros_origin_setting);
  };
};
/**
 * class2api内部对Options跨域预请求的动态响应，独立版本
 * @param req
 * @param res
 * @param next
 * @param _cros_origin_setting
 */


exports.responsiveCrosOriginForGankaoDomainMiddleWare_HOC = responsiveCrosOriginForGankaoDomainMiddleWare_HOC;

var responsiveCrosOriginForGankaoDomainMiddleWare = function responsiveCrosOriginForGankaoDomainMiddleWare(req, res, next, _ref8) {
  var _ref8$cros_origin = _ref8.cros_origin,
      cros_origin = _ref8$cros_origin === void 0 ? [] : _ref8$cros_origin,
      _ref8$cros_headers = _ref8.cros_headers,
      cros_headers = _ref8$cros_headers === void 0 ? [] : _ref8$cros_headers;
  var Origins = "*";

  if (cros_origin.length > 0) {
    Origins = cros_origin.join(",");
  } else {
    //Access-Control-Allow-Origin值动态响应，不再笼统的输出"*"
    //仅限，针对赶考网下的域名做跨域授权，避免'*'带来的安全隐患
    //客户端，ApiProxy组件默认已配置跨域请求，用superagent和fetch的，需要单独配置withCredentials
    var referer = req.get('referer') || req.get('refererclientprovide') || req.get('origin') || '';

    if (referer) {
      var urlObj = _url2["default"].parse(referer); //请求域名存在于defaultTrustDomains以及_cros_origin_setting.trustDomains白名单中


      if ((0, _lodash.filter)([].concat(defaultTrustDomains, _toConsumableArray(cros_origin)), function (item) {
        return (urlObj.hostname || '').indexOf(item) !== -1;
      }).length > 0) {
        Origins = urlObj.protocol + '//' + urlObj.hostname + (urlObj.port ? ":".concat(urlObj.port) : '');
      } // 'http://local.gankao.com:3000'
      // {"protocol":"http:","slashes":true,"auth":null,"host":"local.gankao.com:3000","port":"3000","hostname":"local.gankao.com","hash":null,"search":null,"query":null,"pathname":"/","path":"/","href":"http://local.gankao.com:3000/"}
      // {"protocol":"https:","slashes":true,"auth":null,"host":"local.gankao.com:80","port":"80","hostname":"local.gankao.com","hash":null,"search":null,"query":null,"pathname":"/","path":"/","href":"https://local.gankao.com:80/"}
      // {"protocol":"https:","slashes":true,"auth":null,"host":"local.gankao.com","port":null,"hostname":"local.gankao.com","hash":null,"search":null,"query":null,"pathname":"/","path":"/","href":"https://local.gankao.com/"}

    }

    res.header("refererlog", 'from referer or refererClientProvide:' + referer);
  }

  res.header("Access-Control-Allow-Origin", Origins);
  res.header("Access-Control-Allow-Credentials", "true");
  res.header("Access-Control-Allow-Methods", "HEAD,OPTIONS,POST");
  res.header("Access-Control-Allow-Headers", " " + [].concat(_toConsumableArray(allow_Header), _toConsumableArray(cros_headers)).join(", "));

  if ('OPTIONS' === req.method) {
    res.sendStatus(200);
  } else {
    next();
  }
};
/**
 * 以Express-Router的方式运行API微服务，通常用于在独立的Express站点中增加一个子路由来实现API服务入口
 *
 * @param options
 * @returns {Promise.<*>}
 */


exports.responsiveCrosOriginForGankaoDomainMiddleWare = responsiveCrosOriginForGankaoDomainMiddleWare;

var createServerInRouter =
/*#__PURE__*/
function () {
  var _ref9 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee5(options) {
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (_router) {
              _context5.next = 4;
              break;
            }

            _context5.next = 3;
            return _create_server('router', options);

          case 3:
            _router = _context5.sent;

          case 4:
            return _context5.abrupt("return", _router);

          case 5:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function createServerInRouter(_x8) {
    return _ref9.apply(this, arguments);
  };
}();
/**
 * 快速封装一个{success: true}结构的对象，代表当前API的业务操作成功。可附带扩展属性
 * @param ps
 * @returns {{success: boolean}}
 * @constructor
 */


exports.createServerInRouter = createServerInRouter;

var GKSUCCESS = function GKSUCCESS(ps) {
  if (ps) {
    return _objectSpread2({
      success: true
    }, ps instanceof Object ? ps : {
      msg: ps
    });
  } else {
    return {
      success: true
    };
  }
};

exports.GKSUCCESS = GKSUCCESS;