"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _Decorators = require("./../class2api/Decorators");

var _GKErrors_Inner = require("../class2api/GKErrors_Inner");

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _util = require("./../class2api/util");

var _loadConfig = _interopRequireDefault(require("./loadConfig.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var _getConfig = (0, _loadConfig["default"])(),
    sysName = _getConfig.name,
    admin_rule_center = _getConfig.admin_rule_center;

var RuleValidator =
/*#__PURE__*/
function () {
  function RuleValidator() {
    _classCallCheck(this, RuleValidator);

    throw new Error('静态业务功能类无法实例化');
  }
  /**
   * 从jstoken值解析后台管理用户的账号
   *
   * @param jstoken
   * @returns {Promise.<*>}
   */
  //这里打开后会导致宿主项目运行启动错误，无解，暂时注释
  // @cacheAble({
  //     cacheKeyGene: ({jwtoken, req}) => {
  //         jwtoken = jwtoken || (req ? (req.header('jwtoken') || req.cookies.jwtoken) : '')
  //         return jwtoken;
  //     }
  // })


  _createClass(RuleValidator, null, [{
    key: "parseAdminAccountFromJWToken",
    value: function () {
      var _parseAdminAccountFromJWToken = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(_ref) {
        var jwtoken, req, frontReq, res, _ref2, err, result, _gankao, _ref3, password, restResult;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                jwtoken = _ref.jwtoken, req = _ref.req;
                jwtoken = jwtoken || (req ? req.header('jwtoken') || req.cookies.jwtoken : '');

                if (jwtoken) {
                  _context.next = 4;
                  break;
                }

                throw _GKErrors_Inner.GKErrors._TOKEN_LOGIN_INVALID("\u6807\u8BB0\u8EAB\u4EFD\u9A8C\u8BC1\u7684jwtoken\u672A\u63D0\u4F9B");

              case 4:
                if (req) {
                  //收集请求发起端的信息
                  frontReq = {
                    ___ip: req.headers['x-forwarded-for'] || req.connection && req.connection.remoteAddress || req.socket && req.socket.remoteAddress || req.connection.socket && req.connection.socket.remoteAddress || '',
                    headers: req.headers,
                    cookies: req.cookies
                  };
                }

                _context.next = 7;
                return (0, _isomorphicFetch["default"])(admin_rule_center.auth, {
                  method: 'post',
                  rejectUnauthorized: false,
                  headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json',
                    'jwtoken': jwtoken
                  },
                  withCredentials: 'true',
                  json: true,
                  body: JSON.stringify({
                    nothing: 1,
                    frontReq: frontReq
                  })
                });

              case 7:
                res = _context.sent;
                _context.next = 10;
                return res.json();

              case 10:
                _ref2 = _context.sent;
                err = _ref2.err;
                result = _ref2.result;

                if (!err) {
                  _context.next = 20;
                  break;
                }

                _gankao = err._gankao;

                if (!(_gankao === '1')) {
                  _context.next = 19;
                  break;
                }

                throw err;

              case 19:
                throw _GKErrors_Inner.GKErrors._TOKEN_LOGIN_INVALID("jwtoken\u65E0\u6CD5\u8BC6\u522B\uFF1A".concat(JSON.stringify(err)));

              case 20:
                if (process.env.PRODUCTION_TYPE !== "production") {
                  console.log("admin_rule_center.auth post result = ".concat(JSON.stringify({
                    err: err,
                    result: result
                  })));
                } //剔除密码


                _ref3 = result || {}, password = _ref3.password, restResult = _objectWithoutProperties(_ref3, ["password"]);
                return _context.abrupt("return", restResult);

              case 23:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function parseAdminAccountFromJWToken(_x) {
        return _parseAdminAccountFromJWToken.apply(this, arguments);
      }

      return parseAdminAccountFromJWToken;
    }() //这里打开后会导致宿主项目运行启动错误，无解，暂时注释
    // @cacheAble({
    //     cacheKeyGene: ({jwtoken = '', categoryName = '', ruleName = ''}) => {
    //         //以jwtoken、功能组名称、权限名称来组合索引，混存上一次的判断结果
    //         return jwtoken ? `_ruleValidator_inner-${hashcode(jwtoken)}-${hashcode(categoryName)}-${hashcode(ruleName)}` : '';
    //     }
    // })

  }, {
    key: "_ruleValidator_inner",
    value: function () {
      var _ruleValidator_inner2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(_ref4) {
        var sysName, jwtoken, categoryName, categoryDesc, ruleName, ruleDesc, codePath, _ref4$apiInvokeParams, apiInvokeParams, frontReq, res, text, jsonResult;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                sysName = _ref4.sysName, jwtoken = _ref4.jwtoken, categoryName = _ref4.categoryName, categoryDesc = _ref4.categoryDesc, ruleName = _ref4.ruleName, ruleDesc = _ref4.ruleDesc, codePath = _ref4.codePath, _ref4$apiInvokeParams = _ref4.apiInvokeParams, apiInvokeParams = _ref4$apiInvokeParams === void 0 ? {} : _ref4$apiInvokeParams, frontReq = _ref4.frontReq;
                _context2.prev = 1;

                if (process.env.NODE_ENV !== "production") {
                  console.log("\u6743\u9650,\u5411\u4E2D\u5FC3\u8BF7\u6C42\u6388\u6743\u8BA4\u8BC1(".concat(admin_rule_center.validator, "\uFF09..."));
                }

                _context2.next = 5;
                return (0, _isomorphicFetch["default"])(admin_rule_center.validator, {
                  method: 'post',
                  rejectUnauthorized: false,
                  headers: {
                    'Accept': 'application/json, text/plain, */*',
                    'Content-Type': 'application/json',
                    'jwtoken': jwtoken
                  },
                  withCredentials: 'true',
                  json: true,
                  body: JSON.stringify({
                    sysName: sysName,
                    categoryName: categoryName,
                    categoryDesc: categoryDesc,
                    ruleName: ruleName,
                    ruleDesc: ruleDesc,
                    codePath: codePath,
                    apiInvokeParams: apiInvokeParams,
                    frontReq: frontReq
                  })
                });

              case 5:
                res = _context2.sent;
                _context2.next = 8;
                return res.text();

              case 8:
                text = _context2.sent;

                if (process.env.NODE_ENV !== "production") {
                  console.log("\u6743\u9650\uFF0C\u6388\u6743\u7ED3\u679C\u8FD4\u56DE\uFF1A");
                  console.log(text);
                }

                _context2.prev = 10;
                jsonResult = JSON.parse(text);

                if (jsonResult.result && jsonResult.result.password) {
                  delete jsonResult.result.password;
                }

                return _context2.abrupt("return", jsonResult);

              case 16:
                _context2.prev = 16;
                _context2.t0 = _context2["catch"](10);
                console.error("\u6743\u9650\uFF0C\u6388\u6743\u7ED3\u679C\u4E3A\u975Ejson\u683C\u5F0F\u7684\u5B57\u7B26\u4E32\uFF0C\u5C01\u88C5\u4E3A{err,result}\u63A5\u53E3...");
                console.error({
                  err: null,
                  result: text
                });
                return _context2.abrupt("return", {
                  err: null,
                  result: text
                });

              case 21:
                _context2.next = 33;
                break;

              case 23:
                _context2.prev = 23;
                _context2.t1 = _context2["catch"](1);

                if (!(process.env.NODE_ENV !== "production")) {
                  _context2.next = 30;
                  break;
                }

                console.error('调用权限认证接口时遇到程序错误，开发环境，将终止程序 ...');
                throw _context2.t1;

              case 30:
                console.error('调用权限认证接口时遇到程序错误，非开发环境，转换为GKErrors._RULE_VALIDATE_ERROR错误继续向下传递 ...');
                console.error(_context2.t1);

              case 32:
                throw _GKErrors_Inner.GKErrors._RULE_VALIDATE_ERROR(_context2.t1);

              case 33:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[1, 23], [10, 16]]);
      }));

      function _ruleValidator_inner(_x2) {
        return _ruleValidator_inner2.apply(this, arguments);
      }

      return _ruleValidator_inner;
    }()
  }]);

  return RuleValidator;
}();

var _default = RuleValidator;
exports["default"] = _default;